; paging shadow screen time
; by Patrik Rak,
; heavily based on btime
; by Jan Bobrowski

	org 49152
	jp RUN

	call INSTINT
	call FRAME_TIME
	ld bc,(FRAMET)
	ret

RUN:
	call INSTINT
	call FRAME_TIME
	call GETVAR
	db "T",13
	ld hl,-(116+8)
	add hl,bc
	ld (T1),hl

	ld a,(0x5b5c)
	ld (PAGES+1),a
	xor 0x08
	ld (PAGES+2),a

	call ALIGNINT
NEXT:			; 46
	im 1		; 54
PAGES:
	ld de, 0	; 64
	ld bc, 0x7FFD	; 74
	out (c), d	; 86
	ld bc, (T1)	; 106
	call DELAY	; 106+T1
	ld bc, 0x7FFD	; 116+T1
	out (c), e	; 128+T1+C1 C1=0..12 on 128k

	ld hl, T2	; 138+T1+C1
	ld bc, (T1)	; 158+T1+C1
	and a		; 162+T1+C1
	sbc hl, bc	; 177+T1+C1
	ld b,h
	ld c,l		; 185+T1+C1
	call DELAY	; 185+T2+C1 T2=57910+124-6-8-192

	ld a,0		; 192+T2+C1
	in a,(0xFE)	; 203+T2+C2 C2=0/8/12 on 128k
	inc a		; 207+T2+C2
	and 1Fh		; 214+T2+C2
	ret nz		; 219+T2+C2
	im 2		; 227+T2+C2

	ld bc,T3-T2	; 237+T2+C2
	call DELAY  ; 237+T3+C2 T3=62721-258

	ld bc, NEXT	; 247+T3+C2
	push bc		; 258+T3+C2
	halt		; 258+T3+4*n = 62721+4*n

	rst 0

	include delay.asm
	include instint.asm
	include frametime.asm
	include alignint.asm
	include getvar.asm

T1 dw 0
T2 equ 57910+124-6-8-192
T3 equ 62721-258
